//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://emule.sf.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
#include "types.h"
#include "listensocket.h"

#define	CS_PENDING			1
#define	CS_ONUPLOADQUEUE	2
#define	CS_ONDOWNLOADQUEUE	3
#define	CS_UPLOADING		4
#define	CS_DOWNLOADING		5

class CClientReqSocket;

class CBaseClient
{
public:
	CBaseClient();
	virtual ~CBaseClient();
	virtual bool	IsUpClient()		{return false;}
	virtual bool	IsDownClient()		{return false;}
	void			Disconnected();	
	uint32			GetUserID()			{return userid;}
	char*			GetUserName()		{return username;}
	int8			GetState();
	uint32			GetIP()				{return userip;}
	bool			HasLowID()			{return (userid < 16777216);}
	CClientReqSocket*	socket;
	char*			GetFullIP()			{return fulluserip;}
	uint32			GetUserPort()		{return userport;}
	uint32			GetDatarate()		{return datarate;}
	uint32			GetTransferedBytes(){return transfered;}
	uint32			listitemnr;
protected:
	bool	isbotuser;
	bool	haslowid;
	bool	isfriend;
	bool	isuploading;
	bool	isemuleclient;
	int8	emuleversion;
	uint32	userip;
	char	serverip[4];
	uint32	userid;
	int16	userport;
	int16	serverport;
	uint32	clientversion;
	uint32	datarate;
	uint32	dataratetmp;
	uint32	dataratems;
	uint32	count;
	char*	username;
	char	fulluserip[21];
	uint32	transfered;
	
};