//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://emule.sf.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// SearchListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "SearchListCtrl.h"


// CSearchListCtrl

IMPLEMENT_DYNAMIC(CSearchListCtrl, CListCtrl)
CSearchListCtrl::CSearchListCtrl()
{
}

void CSearchListCtrl::Init(CSearchList* in_searchlist){
	searchlist = in_searchlist;
	InsertColumn(0,"Filename",LVCFMT_LEFT,250,0);
	InsertColumn(1,"Size",LVCFMT_LEFT,100,1);
	InsertColumn(2,"Sources",LVCFMT_LEFT,50,2);
	InsertColumn(3,"Availability",LVCFMT_LEFT,70,3);
	InsertColumn(4,"Type",LVCFMT_LEFT,55,4);
	InsertColumn(5,"FileID",LVCFMT_LEFT,190,5);
}

CSearchListCtrl::~CSearchListCtrl(){
}

BEGIN_MESSAGE_MAP(CSearchListCtrl, CListCtrl)
END_MESSAGE_MAP()

// CSearchListCtrl message handlers

void CSearchListCtrl::AddResult(CSearchFile* toshow){
	char* name = toshow->GetStrTagValue(FT_FILENAME);
	if (!name)
		return;
	uint32 itemnr = GetItemCount();
	InsertItem(itemnr,name);
	uint32 filesize = toshow->GetIntTagValue(FT_FILESIZE); 
	char buffer[50];
	if (filesize < 1024)
		sprintf(buffer,"%i Bytes",filesize);
	else if (filesize < 1048576)
		sprintf(buffer,"%i KB",filesize/1024);
	else
		sprintf(buffer,"%.1f MB",(float)filesize/1048576);
	SetItemText(itemnr,1,buffer);
	itoa(toshow->GetIntTagValue(FT_SOURCES),buffer,10);
	SetItemText(itemnr,2,buffer);
	SetItemText(itemnr,4,toshow->GetStrTagValue(FT_FILETYPE));
	buffer[0] = 0;
	for (uint16 i = 0;i != 16;i++) // hmm I wonder if there is a standart function for this
		sprintf(buffer,"%s%02X",buffer,toshow->GetFileHash()[i]);
	SetItemText(itemnr,5,buffer);
}

void CSearchListCtrl::UpdateSources(uint32 index, uint32 newvalue){
	char buffer[50];
	itoa(newvalue,buffer,10);
	SetItemText(index,2,buffer);
}
