//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://emule.sf.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// UploadListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "UploadListCtrl.h"


// CUploadListCtrl

IMPLEMENT_DYNAMIC(CUploadListCtrl, CListCtrl)
CUploadListCtrl::CUploadListCtrl(){
}

void CUploadListCtrl::Init(){
	InsertColumn(0,"Username",LVCFMT_LEFT,150,0);
	InsertColumn(1,"File",LVCFMT_LEFT,275,1);
	InsertColumn(2,"Speed",LVCFMT_LEFT,60,2);
	InsertColumn(3,"Transfered",LVCFMT_LEFT,65,3);
	InsertColumn(4,"Waited",LVCFMT_LEFT,60,4);
	InsertColumn(5,"Status",LVCFMT_LEFT,110,5);
	CImageList* imagelist = new CImageList();
	imagelist->Create(16,16,ILC_COLOR,0,10);
	imagelist->SetBkColor(RGB(255,255,255));
	imagelist->Add(theApp.LoadIcon(IDI_USER0));
	this->SetImageList(imagelist,LVSIL_SMALL);
}

CUploadListCtrl::~CUploadListCtrl(){
}

void CUploadListCtrl::AddClient(CUploadClient* client){
	uint32 itemnr = GetItemCount();
	char buffer[100];
	client->listitemnr = InsertItem(itemnr,client->GetUserName(),0);
	sprintf(buffer,"%i min",(client->GetWaitTime())/60000);
	SetItemText(itemnr,4,buffer);
	SetItemText(client->listitemnr,5,"not implemented");
	RefreshClient(client);
}

void CUploadListCtrl::RemoveClient(CUploadClient* client){
	DeleteItem(client->listitemnr);
	client->listitemnr = 0;
}

void CUploadListCtrl::RefreshClient(CUploadClient* client){
	char buffer[100];
	CKnownFile* file = theApp.sharedfiles->GetFileByID(client->reqfileid);
	if (file)
		SetItemText(client->listitemnr,1,file->GetFileName());
	else
		SetItemText(client->listitemnr,1,"?");
	sprintf(buffer,"%.1f KB/s",(float)client->GetDatarate()/1024);
	SetItemText(client->listitemnr,2,buffer);
	if (client->GetTransferedBytes() < 1024)
		sprintf(buffer,"%i Bytes",client->GetTransferedBytes());
	else if (client->GetTransferedBytes() < 1048576)
		sprintf(buffer,"%i KB",client->GetTransferedBytes()/1024);
	else
		sprintf(buffer,"%.1f MB",(float)client->GetTransferedBytes()/1048576);
	SetItemText(client->listitemnr,3,buffer);

}

BEGIN_MESSAGE_MAP(CUploadListCtrl, CListCtrl)
END_MESSAGE_MAP()



// CUploadListCtrl message handlers

